package com.brilliance.isc.funds.crtsel.resource;

import com.brilliance.isc.funds.crtsel.service.CrtselService;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.funds.CrtselQueryVo;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("/crtsel")
public class CrtselResource {
    @Autowired
    private CrtselService crtselService;


    /*
     *
     * */
    @PostMapping("/list")
    public ResponseSet list(@RequestBody CrtselQueryVo crtselQueryVo) {
        return ResponseSet.simpleSuccess(crtselService.list(crtselQueryVo));
    }



    /**
     * 处理按钮查看能够进行的交易
     */
    @ApiOperation("处理按钮查看能够进行的交易")
    @PostMapping("/dealWithByOwnref")
    public ResponseSet dealWithByOwnref(@RequestBody TrnCodeQueryVo trnCodeQueryVo) {
        return ResponseSet.simpleSuccess(crtselService.dealWithByInr(trnCodeQueryVo));
    }

    @ApiOperation("处理按钮查看能够进行的交易")
    @PostMapping("/dealWithByInr")
    public ResponseSet dealWithByInr(@RequestBody TrnCodeQueryVo trnCodeQueryVo) {
        return ResponseSet.simpleSuccess(crtselService.dealWithByInr(trnCodeQueryVo));
    }


    /**
     * 详情页面初始化
     */
    @PostMapping("/selectXxdByPrimaryKey")
    public ResponseSet selectXxdByPrimaryKey(@RequestBody Map<String, String> map) {
        return ResponseSet.simpleSuccess(crtselService.selectXxdByPrimaryKey(map));
    }
}













