package com.brilliance.isc.funds.crtsel.service.impl;

import com.brilliance.isc.bo.Trn;
import com.brilliance.isc.bo.model.Crdgrp;
import com.brilliance.isc.common.sysmod.SysmodService;
import com.brilliance.isc.funds.bo.funds.CrtcriStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtfopStoreBo;
import com.brilliance.isc.funds.common.component.CrToolComponent;
import com.brilliance.isc.funds.crtsel.service.CrtselService;
import com.brilliance.isc.mda.dao.CrdMapper;
import com.brilliance.isc.mda.dao.TrnMapper;
import com.brilliance.isc.vo.TrnCodeQueryVo;
import com.brilliance.isc.vo.TrncodVo;
import com.brilliance.isc.vo.funds.CrdWithPtsCbbResponseVo;
import com.brilliance.isc.vo.funds.CrtselQueryVo;
import com.brilliance.mda.runtime.mda.util.Strings;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.common.collect.Lists;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Objects;

//import com.brilliance.isc.funds.bo.Crdgrp;

@Service
public class CrtselServiceImpl implements CrtselService {

    private Logger logger = LoggerFactory.getLogger(CrtselServiceImpl.class);

    @Autowired
    private CrdMapper crdMapper;

    @Resource
    private TrnMapper trnMapper;

    @Resource
    private SysmodService sysmodService;

    @Autowired
    private CrToolComponent crToolComponent;


    //业务查询
    @Override
    public PageInfo list(CrtselQueryVo crtselQueryVo) {
        //FB+FS

        PageHelper.startPage(crtselQueryVo.getPageNumber(), crtselQueryVo.getPageSize()).setReasonable(true);
        List<CrdWithPtsCbbResponseVo> crdList = crdMapper.queryCrdInfo(crtselQueryVo);
        return new PageInfo(crdList);
    }


    @Override
    public List<TrncodVo> dealWithByInr(TrnCodeQueryVo trnCodeQueryVo) {
        String type = Strings.toUpper(trnCodeQueryVo.getType());
        String inr = trnCodeQueryVo.getInr();

        List<TrncodVo> result = Lists.newArrayList();
        Crdgrp crdgrp = crToolComponent.getCrdgrpByInr(inr);

        if ("I".equals(crdgrp.getRec().getClrtyp())) {
            //汇入清算
            String[] crTraArray = {"CRTCBK", "CRTCTF"};
            String[] crButArray = {"退汇清算", "转汇清算"};
            String isAllowed = "";
            for (int i = 0; i < crTraArray.length; i++) {
                TrncodVo trncodVo = new TrncodVo(crTraArray[i], crButArray[i], isAllowed, "Y", "");
                crToolComponent.isCRTrnAllowed(crdgrp, trncodVo);
                result.add(trncodVo);
            }
        } else if ("O".equals(crdgrp.getRec().getClrtyp())) {
            //汇出清算
            String[] crTraArray = {"CRTCBK", "CRTCTF"};
            String[] crButArray = {"退汇清算", "转汇清算"};
            String isAllowed = "";
            for (int i = 0; i < crTraArray.length; i++) {
                TrncodVo trncodVo = new TrncodVo(crTraArray[i], crButArray[i], isAllowed, "Y", "");
                crToolComponent.isCRTrnAllowed(crdgrp, trncodVo);
                result.add(trncodVo);
            }
        }
        return result;
    }


    @Override
    public Object selectXxdByPrimaryKey(Map<String, String> map) {
        String objinr = map.get("objinr");
        String objtyp = map.get("objtyp");
        String pntinr = map.get("pntinr");
        CrtcriStoreBo crtcriStoreBo = new CrtcriStoreBo();
        crtcriStoreBo.reset();
        if (objinr.length() == 16) {
            Trn trnLid = trnMapper.selectByObjinrTrn(objtyp, objinr, "CRTCRI");
            if (!Objects.isNull(trnLid)) {
                crtcriStoreBo = sysmodService.streamGetNameInSubDir(CrtcriStoreBo.class, trnLid.getInr());
            }
        }
        crtcriStoreBo.setCrdgrp(crToolComponent.getCrdgrpByInr(objinr));
        return crtcriStoreBo;


    }


}
