package com.brilliance.isc.funds.fttfcm.document;

import com.brilliance.isc.bo.Lid;
import com.brilliance.isc.bo.model.Lidgrp;
import com.brilliance.isc.common.doc.TextResultVo;
import com.brilliance.isc.common.trndoc.vo.DoceotVo;
import com.brilliance.isc.common.util.StringUtils;
import com.brilliance.isc.doc.annotation.DocFunc;
import com.brilliance.isc.doc.constant.DocConstant;
import com.brilliance.isc.doc.handle.impl.AbstractTransactionDocSet;
import com.brilliance.isc.funds.bo.funds.FttfcmStoreBo;
import com.brilliance.isc.swift.objmtconvert.manager.MtCreatorManager;
import com.brilliance.isc.swift.objmtconvert.model.mt1xx.MT199Creator;
import com.brilliance.isc.swift.objmtconvert.model.mt2xx.MT299Creator;
import com.brilliance.isc.swift.objmtconvert.result.MtResult;
import com.brilliance.isc.swift.swtmsg.SwiftMessageComponent;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import java.util.HashMap;
import java.util.Map;

import static com.brilliance.isc.doc.constant.DocConstant.COR_TYP_SWT;

@Component("fttfcm.docset")
public class FttfcmDocset extends AbstractTransactionDocSet<FttfcmStoreBo> {

    @Resource
    private BuildFtt320l1 buildFtt320l1;

    @Autowired
    private SwiftMessageComponent swiftMessageComponent;

    @PostConstruct
    public void buildMember() {
        buildLetterProvider("fttfcm","FTT3201","FTT1991","FTT2991");
        //扫描Cortype支持，必须要执行
        scanDocCortypSupport();
    }

    public Map<String,Object> buildExtraMapForLetter(FttfcmStoreBo trnbo, DoceotVo doceotVo){
        if (MdaUtils.compareTo(doceotVo.getDocnam(),"FTT3201")==0){
            return buildFtt320l1.build(trnbo,doceotVo);
        } else {
            return new HashMap<>();
        }
    }


    @DocFunc(name = "ftt3201", cortyp = COR_TYP_SWT)
    public TextResultVo ftt320s1(FttfcmStoreBo bo, DoceotVo doceotVo) {
        MtResult _320MtResult=new MtResult();
        //TODO
        //MtResult _320MtResult=MtCreatorManager.packMT(mt320Creator)
        _320MtResult.setMessage("这是一个临时报文返回，报文组装待开发");
        return buildTextVo(_320MtResult);

    }



    @DocFunc(name = "ftt1991", cortyp = COR_TYP_SWT)
    public TextResultVo ftt199s1(FttfcmStoreBo bo, DoceotVo doceotVo) {
        MT199Creator mt199Creator = new MT199Creator("199");
        mt199Creator.setRecvBic(doceotVo.getAdrbic());
        mt199Creator.setSendBic(swiftMessageComponent.getSendBic());

        //20
        mt199Creator.setTransactionReferenceNumber(bo.getFtdgrp().getRec().getOwnref());

        //21
        if (!StringUtils.isEmpty( bo.getRelref())) {
            mt199Creator.setRelatedReference(bo.getRelref());
        }else{
            mt199Creator.setRelatedReference("NONREF");
        }
        mt199Creator.setNarrative(bo.getNarblk());

        return buildTextVo(MtCreatorManager.packMT(mt199Creator));

    }


    @DocFunc(name = "ftt2991", cortyp = COR_TYP_SWT)
    public TextResultVo ftt299s1(FttfcmStoreBo bo, DoceotVo doceotVo) {
        MT299Creator mt299Creator = new MT299Creator("299");
        mt299Creator.setRecvBic(doceotVo.getAdrbic());
        mt299Creator.setSendBic(swiftMessageComponent.getSendBic());

        //20
        mt299Creator.setTransactionReferenceNumber(bo.getFtdgrp().getRec().getOwnref());

        //21
        if (!StringUtils.isEmpty( bo.getRelref())) {
            mt299Creator.setRelatedReference(bo.getRelref());
        }else{
            mt299Creator.setRelatedReference("NONREF");
        }
        mt299Creator.setNarrative(bo.getNarblk());

        return buildTextVo(MtCreatorManager.packMT(mt299Creator));

    }

    private TextResultVo buildTextVo(MtResult mtResult) {
        if (mtResult != null) {
            TextResultVo textResultVo = new TextResultVo();
            textResultVo.setData(mtResult.getMessage());
            textResultVo.setFormat(DocConstant.TEXT);
            textResultVo.setExtension(DocConstant.SF2);
            textResultVo.setBinary(mtResult.getMessage().getBytes());
            textResultVo.setAttach(mtResult.getAbsMTCreator());
            return textResultVo;
        }
        return null;
    }



}
